#!/usr/local/bin/perl

# -----------------------
# 17:30 8/16/96
# filename:
# write_custom_tables.pl
# revised for perl5/dbi/dbd
#  & GTE site 9/98 by bwm
# written august 1996
# author Barbara Mihalas
# -----------------------

  print "Content-type:text/html\n\n";

require 'getopts.pl';

use Oraperl;

require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_specs.pl';
require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
#require '/data3/clearmark/netscape/cgi-bin/cdata/pl/product_queries.pl';
#require '/data3/clearmark/netscape/cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  define cursors =============================

$DEBUG=0;

# ===== HTML setup ======
  &html_header_1("Product Page with Custom Tables");
# ===== HTML setup ======

  print "<!-- 11/8/97 revision --><BR>\n";

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ==================== SQL Query Cursors =====================

  $GET_DISPLAY_FIELDS  = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         displayorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND displayfield=1
                     AND upper(tablename) = :1";

  $GET_GRAPHICS       =
                 "SELECT a.title, a.caption, a.filename, a.extension,
                         b.pagetype, b.usage
                    FROM graphic_objects a, 
                         graphic_model_association b
                   WHERE b.model = :1
                     AND lower(b.pagetype) = 'product page'
                     AND a.graphicid = b.graphicid";

  $CHECK_TEXT         =
                 "SELECT count(*) 
                    FROM text_model_association
                   WHERE upper(model) = :1
                     AND lower(pagetype) = :2";
  
  $GET_TEXT_FILENAME  =
                 "SELECT a.filename, a.extension, b.pagetype
                    FROM text_objects a, text_model_association b
                   WHERE b.model = :1
                     AND lower(b.usage) = 'product description'
                     AND a.textid = b.textid";

  $GET_COLUMNNAME_E     =
                 "SELECT fieldname, columncaption, fielddisplayname,
                         englishunits
                    FROM field_properties
                   WHERE upper(tablename) = :1
                     AND upper(fieldname) = :2";

  $GET_COLUMNNAME_M     =
                 "SELECT fieldname, columncaption, fielddisplayname,
                         metricunits
                    FROM field_properties
                   WHERE upper(tablename) = :1
                     AND upper(fieldname) = :2";

# ==============  end of cursors =============================
# ==============  end of cursors =============================
# ============================================================
# =================== body of program ========================

  &get_query;

  $modelno = $value[0];
  $pdtablename = $value[1];
  $pdtablename =~ tr/a-z/A-Z/;
  $unittype = $value[2];

  &caw_frameD_back_header;
  &back_to_caw_products;
  print "<P>\n";

  print "<CENTER>\n";
  print "<P><FONT SIZE=5> Product Specifications for $modelno ($unittype)</FONT><P>\n";
  print "</CENTER>\n";

  &write_table($modelno, $unittype);

  &display_graphic ($modelno);

  print "<P><P>\n";
 
  &write_pd_text($modelno);
 
# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================

# =============== start of subroutines =======================
# *************************************************************
# Locate and display the related graphic
# *************************************************************
sub display_graphic
{
   local ($modelin) = @_;

   $csrb = &ora_open($lda, $GET_GRAPHICS)      || die $ora_errstr;
   &ora_bind ($csrb, $modelin);

   while ( ($photo_title, $photo_caption, $photo_filename, $photo_extension,
           $photo_pagetype, $photo_usage) = &ora_fetch($csrb) )
   {
      $photo_filename =~ tr/a-z/A-Z/;
      $photo_filename_uc = $photo_filename;
      $photo_filename =~ tr/A-Z/a-z/;
      $photo_filename_lc = $photo_filename;
      $photo_filename_uc = $photo_filename_uc.".jpg";
      $photo_filename_lc = $photo_filename_lc.".jpg";
      $IMG_SRC = $docpath."com_media/".$photo_filename_lc;
      $IMG_ALT = $docpath."com_media/".$photo_filename_uc;

      $IMG_SRC = \"$IMG_SRC\"\n";
      $IMG_ALT = \"$IMG_ALT\"\n";
      print "<CENTER>\n";
      print "<IMG SRC =\"$IMG_SRC  ALT=\"$IMG_ALT ALIGN=CENTER>\n";
      print "</CENTER>\n";
   }
   &ora_close($csrb);
}

# *************************************************************
# Write the product description text
# *************************************************************
sub write_pd_text
{
   local ($modelin) = @_;

   $csrb = &ora_open($lda, $CHECK_TEXT)        || die $ora_errstr;
   $csrd = &ora_open($lda, $GET_TEXT_FILENAME) || die $ora_errstr;

   &ora_bind ($csrb, $modelin, 'product page');
   &ora_bind ($csrd, $modelin);

#  print "after open and bind of cursors to write_pd_text for $modelin <BR>\n";

# get and print product description text file
# -------------------------------------------
   while ( ($textno) = &ora_fetch ($csrb) )
   {
       $ntext = $textno;
   }
   &ora_close ($csrb);

   if ($ntext > 0 )
   {
      while (  ($text_filename, $text_extension, $text_pagetype)
         = &ora_fetch($csrd) )
      {
      #  print "$model has text file [$text_filename]-[$text_extension] 
      #  for page [$text_pagetype]<BR>\n";
         $text_filename_stem = $text_filename;
         $text_filename_stem =~ s/\s/_/g;
         $text_filename_stem =~ s/-/_/g;
         $text_filename = $text_filename_stem.".html";
         $text_location = $textpath.$text_filename;
         $text_filenameA = $text_filename_stem.".htm";
         $text_locationA = $textpath.$text_filenameA;
      #  print "Unix location is [$text_location<BR>\n";

         $text1 = "Unix text filename is [ $text_filename ] or [ $text_filenameA]\n";
         $text_link = $text_location;

         $text_link = $text_location;
         $text_linkA = $text_locationA;
      }
      &ora_close($csrd);
      open(TEXTFILE, $text_link) || open(TEXTFILE, $text_linkA) || print "<BR>\n";
      while (<TEXTFILE>)
      {
         chop;
         print "$_\n";
      } 
      close TEXTFILE;
   }
}

# *************************************************************
# Write the custom product data table
# *************************************************************
sub write_table
{
   local($modelin, $unittype) = @_;

   $unittypelc = $unittype;
   $unittypelc =~ tr/A-Z/a-z/;

   if ($unittypelc eq 'english')
   {
      $csra = &ora_open($lda, $GET_COLUMNNAME_E)    || print "<!-- failed to open  $GET_COLUMNNAME_E --><BR>\n";
   }
   elsif ($unittypelc eq 'metric')
   { 
      $csra = &ora_open($lda, $GET_COLUMNNAME_M)    || print "<!-- failed to open  $GET_COLUMNNAME_M --><BR>\n";
   }
   else 
   { 
      $csra = &ora_open($lda, $GET_COLUMNNAME_E)    || print "<!-- failed to open  $GET_COLUMNNAME_E --><BR>\n";
   }

   &write_comment("query to get column headers is $GET_COLUMNNAME");
   $fieldname[0] = "ModelSize";
   for ($ii =0; $ii <= ($fields-2); $ii++)
   {
      $ord[$ii] = $ii; 
      if ($ii == 0) {
         $fieldname[0] = "ModelSize";
      }
      else {
         $fieldname[$ii] = $value[$ii +2];
      }
      $fntemp = $fieldname[$ii];
      $fntemp =~ tr/a-z/A-Z/;
      &write_comment( "$pdtablename, $fntemp");
      &ora_bind($csra, $pdtablename, $fntemp);
      while ( ($fname, $cname, $fdname, $funits) = &ora_fetch($csra) ) 
      {
          $fielddisplayname[$ii] = $fdname;
          $columnname[$ii] = $cname;
          $units[$ii] = $funits;
      }
      &write_comment("$ii, order = $ord[$ii], $fieldname[$ii], colcap = $columnname[$ii]");
   }
   &ora_close($csra);

#  Get Cursor for Correct Data Table and determine indexes for default fields
#  --------------------------------------------------------------------------

   if ($pdtablename eq 'CAES_CHILLER')                  { $GET_DATA = $CAES_CHILLER }
   if ($pdtablename eq 'CMUS_AIR_CONDENSER')            { $GET_DATA = $CMUS_AIR_CONDENSER }
   if ($pdtablename eq 'CMUS_AIR_HANDLER')              { $GET_DATA = $CMUS_AIR_HANDLER }
   if ($pdtablename eq 'CMUS_AIR_TERMINAL')             { $GET_DATA = $CMUS_AIR_TERMINAL }
   if ($pdtablename eq 'CMUS_AIR_TERMINAL_BOX')         { $GET_DATA = $CMUS_AIR_TERMINAL_BOX }
   if ($pdtablename eq 'CMUS_BOOT_DIFFUSER')            { $GET_DATA = $CMUS_BOOT_DIFFUSER }
   if ($pdtablename eq 'CMUS_CHILLER')                  { $GET_DATA = $CMUS_CHILLER }
   if ($pdtablename eq 'CMUS_DUAL_FUEL_HEAT_PUMP')      { $GET_DATA = $CMUS_DUAL_FUEL_HEAT_PUMP }
   if ($pdtablename eq 'CMUS_DUCTFREE_COOLING')         { $GET_DATA = $CMUS_DUCTFREE_COOLING }
   if ($pdtablename eq 'CMUS_DUCTFREE_HEATPUMP')        { $GET_DATA = $CMUS_DUCTFREE_HEATPUMP }
   if ($pdtablename eq 'CMUS_FANCOILS')                 { $GET_DATA = $CMUS_FANCOILS }
   if ($pdtablename eq 'CMUS_INDOOR_HORZ_PACK')         { $GET_DATA = $CMUS_INDOOR_HORZ_PACK }
   if ($pdtablename eq 'CMUS_INDOOR_VERT_PACK')         { $GET_DATA = $CMUS_INDOOR_VERT_PACK }
   if ($pdtablename eq 'CMUS_INDUCTION_UNIT')           { $GET_DATA = $CMUS_INDUCTION_UNIT }
   if ($pdtablename eq 'CMUS_LPACKROOF_EHEAT_ECOOL')    { $GET_DATA = $CMUS_LPACKROOF_EHEAT_ECOOL }
   if ($pdtablename eq 'CMUS_LPACKROOF_GHEAT_ECOOL')    { $GET_DATA = $CMUS_LPACKROOF_GHEAT_ECOOL }
   if ($pdtablename eq 'CMUS_PACKROOF_EHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_EHEAT_ECOOL }
   if ($pdtablename eq 'CMUS_PACKROOF_GHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_GHEAT_ECOOL }
   if ($pdtablename eq 'CMUS_PACK_AIR_HANDLER')         { $GET_DATA = $CMUS_PACK_AIR_HANDLER }
   if ($pdtablename eq 'CMUS_PACK_ELEC_COOL')           { $GET_DATA = $CMUS_PACK_ELEC_COOL }
   if ($pdtablename eq 'CMUS_PACK_GAS_HEAT_ELEC_COOL')  { $GET_DATA = $CMUS_PACK_GAS_HEAT_ELEC_COOL }
   if ($pdtablename eq 'CMUS_PACK_HEATING_AND_COOLING') { $GET_DATA = $CMUS_PACK_HEATING_AND_COOLING }
   if ($pdtablename eq 'CMUS_PACK_HEATPUMP')            { $GET_DATA = $CMUS_PACK_HEATPUMP }
   if ($pdtablename eq 'CMUS_PACK_ROOFTOP_HEATPUMP')    { $GET_DATA = $CMUS_PACK_ROOFTOP_HEATPUMP }
   if ($pdtablename eq 'CMUS_PACK_TERMINAL_UNIT')       { $GET_DATA = $CMUS_PACK_TERMINAL_UNIT }
   if ($pdtablename eq 'CMUS_SPLIT_SYSTEM')             { $GET_DATA = $CMUS_SPLIT_SYSTEM }
   if ($pdtablename eq 'CMUS_SPLIT_SYSTEM_HEATPUMP')    { $GET_DATA = $CMUS_SPLIT_SYSTEM_HEATPUMP }
   if ($pdtablename eq 'CMUS_UNIT_VENTILATOR')          { $GET_DATA = $CMUS_UNIT_VENTILATOR }
   if ($pdtablename eq 'CMUS_WATER_SOURCE_HEATPUMP')    { $GET_DATA = $CMUS_WATER_SOURCE_HEATPUMP }
   if ($pdtablename eq 'RAC_UNITS_HC')                  { $GET_DATA = $RAC_UNITS_HC }
   if ($pdtablename eq 'RAC_UNITS_COOL_ONLY')           { $GET_DATA = $RAC_UNITS_COOL_ONLY }
   if ($pdtablename eq 'RAC_UNITS_HEAT_COOL')           { $GET_DATA = $RAC_UNITS_HEAT_COOL }
   if ($pdtablename eq 'RAC_UNITS_HEAT_PUMP')           { $GET_DATA = $RAC_UNITS_HEAT_PUMP }

   &write_comment("product data table name is $pdtablename ");
   &write_comment("query is $GET_DATA");

   $csrc = &ora_open($lda, $GET_DATA)      || print "<!-- failed to open $GET_DATA\n -->";
   @fldnames  = &ora_titles($csrc);
   @flengths  = &ora_lengths($csrc);
   @ftypes    = &ora_types($csrc);

#  Get the indexes for the $#ord default fields 
#  -----------------------------------------------
   for ($ii=0; $ii <= $#ord; $ii++)
   {
      $fieldname[$ii] =~ tr/a-z/A-Z/;
    # Get matching fieldname
    # ----------------------
      for ($idat=0; $idat <= $#fldnames; $idat++) 
      {
         $fldnames[$idat] =~ tr/a-z/A-Z/;
         if ($fieldname[$ii] eq $fldnames[$idat] )
         {
            $tord[$ii] = $idat;
        #   print "$idat, tord[$ii] = $tord[$ii], fieldname[$ii]=$fieldname[$ii],";
        #   print "fldname = $fldnames[$tord[$ii] ]<BR> \n";
         }
      }
   }

   $imsize = -1;
   print "<CENTER>\n";
#  print "<FONT SIZE=4> Product Specifications for Model $modelin </FONT><P>\n";
   print "<TABLE BORDER=3> \n";
   print "<TR>\n";
   for ($ii=0; $ii <= $#fldnames; $ii++)
   {
       $fldnames[$ii] =~ tr/a-z/A-Z/;
       if ($fldnames[$ii] eq 'MODEL')
       {   $imodel = $ii; }
       if ($fldnames[$ii] eq 'MODELSIZE')
       {
           $imsize =$ii;
           print "<TD ALIGN=\"center\">Model</TD> \n";
       }
       if ($fldnames[$ii] eq 'MODEL_SIZE')
       {
           $imsize =$ii;
           print "<TD ALIGN=\"center\">Model</TD> \n";
       }
       if ($fldnames[$ii] eq 'RECORD_ID')
       {
           $imrecordid =$ii;
         #  print "<TD ALIGN=\"center\">Model</TD> \n";
       }
   }
   $i0 = 0;
   if ( $pdtablename eq 'CAES_CHILLER' )
   {
      $i0 = 1;
   }
   for ($i=$i0; $i <= $#ord; $i++) {
      print "<TD ALIGN=\"center\">"; 
      if($columnname[$i] ne '') {print "$columnname[$i] ";}
      else {print "$fieldname[$i]*";}
      if ($units[$i] ne '') {print "<BR>($units[$i])";}
      print " </TD>\n";
   }
   print "</TR>\n";


   $procedure = 'write_model_page2.sh?';
   &ora_bind ($csrc, $modelin);
   &write_comment("bind $csrc to model $modelin");
   $unitstr = 'unittype='.$unittype;
   while (  ( @pdata) = &ora_fetch($csrc)  )
   {
       print "<TR> \n";
       if ($imsize >= 0)
       {
          $mdl = $pdata[$imodel].$pdata[$imsize];
          $mdlstr = 'mdlno='.$pdata[$imodel].'&mdlsize='.$pdata[$imsize];
          $recidstr = 'recid='.$pdata[$imrecordid];
          $mdlstr = join ('&', $mdlstr, $unitstr, $recidstr);
          print "<TD ALIGN=CENTER>";
          print "<A HREF=\"$plpath1$procedure$mdlstr\">$mdl</A></TD>\n";
       }
       for ($ij =$i0; $ij<= $#ord; $ij++) 
       {
          if ($pdata[$tord[$ij] ] eq '') { $pdata[$tord[$ij] ] = 'NA';}
          print " <TD ALIGN=\"center\"> $pdata[$tord[$ij] ] </TD>\n";
       }
       print "</TR>\n";
   }
   print "</TABLE>\n";
   $currentdate = &formatdate;
   print "<FONT SIZE=2>$currentdate</FONT>\n";
   print "<BR><FONT SIZE=2>Specifications subject to change without notice.</FONT><BR>\n";
   print "</CENTER><BR>\n";
   print "<HR><P><P>\n";

   &ora_close ($csrc);

}

# *************************************************************
# Obtain the value of a specific field
# *************************************************************

sub get_value 
{
      local( $name_in) = @_ ;
      
      print "\n <BR>(in get_value) name for which value is requested is $name_in<BR>\n";
      print " number of fields is $fields <BR>\n";
      for ($i=0; $i<= $fields; $i++) {
          if ($name_in eq $name[$i] ) {
             print "name in is $name_in; matches name  $name[$i]; with value $value[$i]<BR> \n";
             $value_out = $value[$i];
             print "return from get_value<BR>\n";
             return $value_out; 
          }
      }
}


# ******************************************
# write caw back to product list header
# ******************************************
sub back_to_caw_products
{
   print "<BR>\n";
   print "<A HREF=\"$plpath/write_gen_types_B.sh\">\n";
   print "<I>back to product list</I></A>\n";
   print "<BR>\n";
}

# ******************************************
# Write the HTML header
# ******************************************
sub html_header 
{
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print +"<HEAD>\n";
 print +"<TITLE>Product Data Table and Information</TITLE>\n";
 print +"</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

