#!/usr/local/bin/perl

# -----------------------
# filename:
# write_model_page2.pl
# revised for perl5/dbi/dbd
#  & GTE site 9/98 by bwm
# revised for perl5 9/98
# rewritten oct 1997
# author Barbara Mihalas
# -----------------------

  print "Content-type:text/html\n\n";

require 'getopts.pl';

use Oraperl;

require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_specs.pl';
require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_paths.pl';
require '/data3/clearmark/netscape/cgi-bin/cdata/pl/custom_page2_tables.pl';

# ==============  define cursors =============================
#require '/data3/clearmark/netscape/cgi-bin/cdata/pl/product_queries.pl';
#require '/data3/clearmark/netscape/cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  define cursors =============================

# ===== HTML setup ======
  &html_header_1("Complete data listing by model number");
# ===== HTML setup ======

  &write_comment("End of HTML setup; 11/8/97 revision");

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ==============  define cursors =============================
  $GET_TABLE   = "SELECT distinct datatablename 
                    FROM commercial_products 
                   ORDER BY datatablename";
 
  $GET_TABLENAME   =
                 "SELECT datatablename 
                    FROM commercial_products 
                   WHERE model = :1";
 
  $GET_DEFAULT_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         defaultfieldorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND defaultfield=1
                     AND upper(tablename) = :1";
 
  $GET_DISPLAY_FIELDS_ENGLISH = 
                 "SELECT DISTINCT fieldname, columncaption, fielddisplayname,
                         displayorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND displayfield=1
                     AND upper(tablename) = :1";
 
  $GET_DISPLAY_FIELDS_METRIC = 
                 "SELECT DISTINCT fieldname, columncaption, fielddisplayname,
                         displayorder, metricunits
                    FROM field_properties
                   WHERE (units=2 OR units=0) 
                     AND displayfield=1
                     AND upper(tablename) = :1";

  $GET_TEXT_FILENAME  =
                 "SELECT a.filename, a.extension, b.pagetype
                    FROM text_objects a, text_model_association b
                   WHERE b.model = :1
                     AND lower(b.pagetype) = 'product page'
                     AND a.textid = b.textid";

  $GET_GRAPHICS       =
                 "SELECT a.title, a.caption, a.filename, a.extension,
                         b.pagetype, b.usage
                    FROM graphic_objects a, 
                         graphic_model_association b
                   WHERE b.model = :1
                     AND lower(b.pagetype) = 'product page'
                     AND a.graphicid = b.graphicid";

  $CHECK_TEXT         =
                 "SELECT count(*) 
                    FROM text_model_association
                   WHERE upper(model) = :1
                     AND lower(pagetype) = :2";
  
# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

  &get_query;

  $modelno = $value[0];
  $mdlsize = $value[1];
  $unit_type = $value[2];
  $recid     = $value[3];

  &write_display_page2($modelno, $mdlsize, $unit_type);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================

# =============== start of subroutines =======================

# ***************************************************
# Get display fields and build page2 table
# ***************************************************
sub write_display_page2
{
   local ($modelin, $mdlsz, $unittype) = @_;

   &caw_frameD_back_header;
   print "<BR>\n";
   &back_to_caw_products;
   print "<BR>\n";

   $unittypelc = $unittype;
   $unittypelc =~ tr/A-Z/a-z/;

   $GET_TABLENAME = "SELECT datatablename
                         FROM commercial_products
                        WHERE upper(model) = :1";  

   print "<!-- Input model to write_default_table is $modelin -->\n";

   $csra = &ora_open($lda, $GET_TABLENAME)        || 
                     &write_comment ("failed to open cursor $GET_TABLENAME");

   if ($unittypelc eq 'english') {
      $csrb = &ora_open($lda, $GET_DISPLAY_FIELDS_ENGLISH)   || 
                     &write_comment ("failed to open cursor $GET_DISPLAY_FIELDS_ENGLISH");
   }
   elsif ($unittypelc eq 'metric') {
      $csrb = &ora_open($lda, $GET_DISPLAY_FIELDS_METRIC)   || 
                     &write_comment ("failed to open cursor $GET_DISPLAY_FIELDS_METRIC");
   }
   else  {
      $csrb = &ora_open($lda, $GET_DISPLAY_FIELDS_ENGLISH)   || 
                     &write_comment ("failed to open cursor $GET_DISPLAY_FIELDS_ENGLISH");
   }

#  Get Name of Product Data Table for input model
# -----------------------------------------------
   $pdmodel = $modelin;
   $pdmdlsize = $mdlsz;
   &ora_bind($csra, $pdmodel);
   while (  ($pdtblname) = &ora_fetch($csra) )
   {
      $pdtablename = $pdtblname;
      $pdtablename =~ tr/a-z/A-Z/;
      print "<!-- product data tablename is $pdtablename --> \n";
   }
   &ora_close ($csra);


#  Get the default fields for pdtablename
#  --------------------------------------
   if ($pdtablename ne '')
   {
      print "<!-- product data tablename is now $pdtablename --> \n";
 
      $bindstatus = &ora_bind ($csrb, $pdtablename); 
      &write_comment("bind status for getting fieldname info is $bindstatus");
      $ii=0;
      $iordmax = 0;
      while ( ($fname, $cname, $fdname, $forder, $funits) = &ora_fetch($csrb) ) 
      {
         &write_comment("successful fetch for ii = $ii");
         $ord[$ii] = $forder; 
         $iord = $ord[$ii];
         if ($iord > $iordmax)
         {
            $iordmax = $iord;
         }
         $ofieldname[$iord] = $fname;
         $ofielddisplayname[$iord] = $fdname;
         $ocolumnname[$iord] = $cname;
         $ounits[$iord] = $funits;
         if ($ocolumnname[$iord] eq '')
         {
            $ocolumnname[$iord] = $ofieldname[$iord].'*';
         }
         &write_comment("iord=$ord[$ii], $ofieldname[$iord], $ofielddisplayname[$iord], 
                       $ocolumnname[$iord], $ounits[$iord]");
         
         $ii++;
      }

#  Get Cursor for Correct Data Table and determine indexes for default fields
#  --------------------------------------------------------------------------

      if ($pdtablename eq 'CAES_CHILLER')                  { $GET_DATA = $CAES_CHILLER }
      if ($pdtablename eq 'CMUS_AIR_CONDENSER')            { $GET_DATA = $CMUS_AIR_CONDENSER }
      if ($pdtablename eq 'CMUS_AIR_HANDLER')              { $GET_DATA = $CMUS_AIR_HANDLER }
      if ($pdtablename eq 'CMUS_AIR_TERMINAL')             { $GET_DATA = $CMUS_AIR_TERMINAL }
      if ($pdtablename eq 'CMUS_AIR_TERMINAL_BOX')         { $GET_DATA = $CMUS_AIR_TERMINAL_BOX }
      if ($pdtablename eq 'CMUS_BOOT_DIFFUSER')            { $GET_DATA = $CMUS_BOOT_DIFFUSER }
      if ($pdtablename eq 'CMUS_CHILLER')                  { $GET_DATA = $CMUS_CHILLER }
      if ($pdtablename eq 'CMUS_DUAL_FUEL_HEAT_PUMP')      { $GET_DATA = $CMUS_DUAL_FUEL_HEAT_PUMP }
      if ($pdtablename eq 'CMUS_DUCTFREE_COOLING')         { $GET_DATA = $CMUS_DUCTFREE_COOLING }
      if ($pdtablename eq 'CMUS_DUCTFREE_HEATPUMP')        { $GET_DATA = $CMUS_DUCTFREE_HEATPUMP }
      if ($pdtablename eq 'CMUS_FANCOILS')                 { $GET_DATA = $CMUS_FANCOILS }
      if ($pdtablename eq 'CMUS_INDOOR_HORZ_PACK')         { $GET_DATA = $CMUS_INDOOR_HORZ_PACK }
      if ($pdtablename eq 'CMUS_INDOOR_VERT_PACK')         { $GET_DATA = $CMUS_INDOOR_VERT_PACK }
      if ($pdtablename eq 'CMUS_INDUCTION_UNIT')           { $GET_DATA = $CMUS_INDUCTION_UNIT }
      if ($pdtablename eq 'CMUS_LPACKROOF_EHEAT_ECOOL')    { $GET_DATA = $CMUS_LPACKROOF_EHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_LPACKROOF_GHEAT_ECOOL')    { $GET_DATA = $CMUS_LPACKROOF_GHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACKROOF_EHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_EHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACKROOF_GHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_GHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACK_AIR_HANDLER')         { $GET_DATA = $CMUS_PACK_AIR_HANDLER }
      if ($pdtablename eq 'CMUS_PACK_ELEC_COOL')           { $GET_DATA = $CMUS_PACK_ELEC_COOL }
      if ($pdtablename eq 'CMUS_PACK_GAS_HEAT_ELEC_COOL')  { $GET_DATA = $CMUS_PACK_GAS_HEAT_ELEC_COOL }
      if ($pdtablename eq 'CMUS_PACK_HEATING_AND_COOLING') { $GET_DATA = $CMUS_PACK_HEATING_AND_COOLING }
      if ($pdtablename eq 'CMUS_PACK_HEATPUMP')            { $GET_DATA = $CMUS_PACK_HEATPUMP }
      if ($pdtablename eq 'CMUS_PACK_ROOFTOP_HEATPUMP')    { $GET_DATA = $CMUS_PACK_ROOFTOP_HEATPUMP }
      if ($pdtablename eq 'CMUS_PACK_TERMINAL_UNIT')       { $GET_DATA = $CMUS_PACK_TERMINAL_UNIT }
      if ($pdtablename eq 'CMUS_SPLIT_SYSTEM')             { $GET_DATA = $CMUS_SPLIT_SYSTEM }
      if ($pdtablename eq 'CMUS_SPLIT_SYSTEM_HEATPUMP')    { $GET_DATA = $CMUS_SPLIT_SYSTEM_HEATPUMP }
      if ($pdtablename eq 'CMUS_UNIT_VENTILATOR')          { $GET_DATA = $CMUS_UNIT_VENTILATOR }
      if ($pdtablename eq 'CMUS_WATER_SOURCE_HEATPUMP')    { $GET_DATA = $CMUS_WATER_SOURCE_HEATPUMP }
      if ($pdtablename eq 'RAC_UNITS_HC')                  { $GET_DATA = $RAC_UNITS_HC }
      if ($pdtablename eq 'RAC_UNITS_COOL_ONLY')           { $GET_DATA = $RAC_UNITS_COOL_ONLY }
      if ($pdtablename eq 'RAC_UNITS_HEAT_COOL')           { $GET_DATA = $RAC_UNITS_HEAT_COOL }
      if ($pdtablename eq 'RAC_UNITS_HEAT_PUMP')           { $GET_DATA = $RAC_UNITS_HEAT_PUMP }

      print "<P>\n";

      $csrc = &ora_open($lda, $GET_DATA)      || die "failed to open $GET_DATA\n";
      @fldnames  = &ora_titles($csrc);
      @flengths  = &ora_lengths($csrc);
      @ftypes    = &ora_types($csrc);

#  Get the indexes for the $#ord display fields 
#  -----------------------------------------------

      $ifld = 0;
      for ($ii=0; $ii <= $iordmax; $ii++)
      {
         if ($ofieldname[$ii] ne '')
         {
            $fieldname[$ifld] = $ofieldname[$ii]; 
            $fieldname[$ifld] =~ tr/a-z/A-Z/;
            $columnname[$ifld] =  $ocolumnname[$ii];
            $units[$ifld]      =  $ounits[$ii];
            $index[$ifld]      =  $ii;
            &write_comment("the $ifld th fieldname is $fieldname[$ifld]");
            
         # Get matching fieldname
         #-----------------------
            for ($idat=0; $idat <= $#fldnames; $idat++) 
            {
               $fldnames[$idat] =~ tr/a-z/A-Z/;
               if ($fieldname[$ifld] eq $fldnames[$idat] )
               {
                  $tord[$ifld] = $idat;
                  $order[$idat] = $ifld;
               }
            }
            $ifld++;
         }
      }
      $numfields = $ifld-1;

     # Write the return page
     #-----------------------

      print "<A NAME=\"product_data\"></A>\n";
      print "<CENTER>\n";
      print "<FONT SIZE=4>Product Specifications for Model $pdmodel ($unittype)</FONT><P>\n";


      print "<CENTER>\n";
      print "<TABLE BORDER=3 \n";
      print "<TR><TD ALIGN=left>Model</TD>\n";
      print "<TD ALIGN=center>$pdmodel</TD></TR>\n";
      print "<TR><TD ALIGN=left>Model Size</TD>\n";
      print "<TD ALIGN=center>$pdmdlsize</TD></TR>\n";
      &ora_bind ($csrc, $pdmodel, $recid);
      while (  ( @pdata) = &ora_fetch($csrc)  )
      {
          for ($ij =0; $ij<= $#ord; $ij++) 
          {
             if ($pdata[$tord[$ij] ] ne '' && $columnname[$ij] ne '')
             {
                print "<TR> \n";
                print "<TD ALIGN=\"left\"> $columnname[$ij]";  
                if ($units[$ij] ne '') { print "  ($units[$ij])"; }
                print "</TD>";
                print " <TD ALIGN=\"center\"> $pdata[$tord[$ij] ] </TD>";
                print "</TR>\n";
             }
          }
      }
      print "</TABLE>\n";
      $currentdate = &formatdate;
      print "<FONT SIZE=2>$currentdate</FONT>\n";
      print "<BR><FONT SIZE=2>Specifications subject to change without notice.</FONT><BR>\n";
      print "</CENTER>\n";
      print "</TABLE>\n";

      &ora_close ($csrc);
   }
   &ora_close($csrb);
}

# ******************************************
# Writes the product page for input model
# ******************************************
sub write_modelpage
{
   local ($modelin) = @_;

   print "<A NAME=\"pagetop\"></A>\n";
   print "<P><BR>\n";

 # Check for product data
 # ----------------------
   $csrtab = &ora_open($lda, $GET_TABLENAME) || die $ora_errstr;
   &ora_bind ($csrtab, $modelin);
   ($tablename) = &ora_fetch($csrtab);
   if ($tablename ne '') 
   {
      print "<A HREF=\"#product_data\">";
      print "down to product data</A><BR>\n";
   }
   &ora_close($csrtab);

   $csra = &ora_open($lda, $GET_TEXT_FILENAME) || die $ora_errstr;
   $csrb = &ora_open($lda, $GET_GRAPHICS)      || die $ora_errstr;
   $csrc = &ora_open($lda, $CHECK_TEXT)        || die $ora_errstr;

   &ora_bind ($csra, $modelin);
   &ora_bind ($csrb, $modelin);
   &ora_bind ($csrc, $modelin, 'product page');

   print "<CENTER><FONT SIZE=5>\n";
   print "<P>Product Information for $modelin <BR>\n";
   print "</FONT></CENTER>\n";

   while ( ($photo_title, $photo_caption, $photo_filename, $photo_extension,
           $photo_pagetype, $photo_usage) = &ora_fetch($csrb) )
   {
      $photo_filename =~ tr/a-z/A-Z/;
      $photo_filename_uc = $photo_filename;
      $photo_filename =~ tr/A-Z/a-z/;
      $photo_filename_lc = $photo_filename;
      $photo_filename_uc = $photo_filename_uc.".jpg";
      $photo_filename_lc = $photo_filename_lc.".jpg";
      $IMG_SRC = $docpath."com_media/".$photo_filename_lc;
      $IMG_ALT = $docpath."com_media/".$photo_filename_uc;

      $IMG_SRC = "\"$IMG_SRC\"\n";
      $IMG_ALT = "\"$IMG_ALT\"\n";
      print "<CENTER>\n";
      print "<IMG SRC =\"$IMG_SRC  ALT=\"$IMG_ALT ALIGN=CENTER>\n";
      print "</CENTER>\n";
   }
   &ora_close($csrb);
   print "<P><P>\n";

   while ( ($textno) = &ora_fetch ($csrc) )
   {
       $ntext = $textno;
   }
   &ora_close ($csrc);

   if ($ntext > 0 )
   {
      while (  ($text_filename, $text_extension, $text_pagetype)
         = &ora_fetch($csra) )
      {
         $text_filename =~ s/\s/_/g;
         $text_filename =~ s/-/_/g;
         $text_filename = $text_filename.".html";
         $text_location = $textpath.$text_filename;
         $text_link = $text_location;
      }
      &ora_close($csra);
      open(TEXTFILE, $text_link) || die "can't open filename $text_link\n";
      while (<TEXTFILE>)
      {
         chop;
         print "$_\n";
      } 
      close TEXTFILE;
   }
   &write_default_table ($modelin);   
}
