#!/usr/local/bin/perl

# -----------------------
# filename:
# write_model_page2.pl
# revised for perl5/dbi/dbd
#  & GTE site 9/98 by bwm
# revised to perl5 9/98
# written august 1996
# author Barbara Mihalas
# -----------------------

$DEBUG = 0;

  print "Content-type:text/html\n\n";

require 'getopts.pl';

use Oraperl;

require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_specs.pl';
require '/data3/clearmark/netscape/cgi-bin/cdata/pl/user_paths.pl';
require '/data3/clearmark/netscape/cgi-bin/cdata/pl/write_modelp2_queries.pl';

# ==============  define cursors =============================
#require '/data3/clearmark/netscape/cgi-bin/cdata/pl/product_queries.pl';
#require '/data3/clearmark/netscape/cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  define cursors =============================

# ===== HTML setup ======
  &html_header_1("Second Product Page for Room Air Conditioners");
# ===== HTML setup ======

$text_object_table = 'text_objects';

  &write_comment("9/98 revision");
  &write_comment("11/8/97 revision");

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ==============  define cursors =============================

  $GET_TABLENAME   =
                 "SELECT datatablename 
                    FROM commercial_products 
                   WHERE model = :1";
 
  $GET_DEFAULT_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         defaultfieldorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND defaultfield=1
                     AND upper(tablename) = :1";
 
  $GET_DISPLAY_FIELDS = 
                 "SELECT DISTINCT fieldname, columncaption, fielddisplayname,
                         displayorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND displayfield=1
                     AND upper(tablename) = :1";
 

# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

  &get_query;

  $modelno = $value[0];
  $mdlsize = $value[1];

  &write_comment(" model $modelno; modelsize $mdlsize");

  &write_display_page2($modelno, $mdlsize);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================

# =============== start of subroutines =======================

# ***************************************************
# This Procedure shows default and display fields 
# ***************************************************
sub show_default_table_fields {

   $csra  = &ora_open($lda, $GET_TABLE) || die $ora_errstr;
   $csrb  = &ora_open($lda, $GET_DEFAULT_FIELDS) || die $ora_errstr;
   $csrc  = &ora_open($lda, $GET_DISPLAY_FIELDS) || die $ora_errstr;

   while ( ($pdtblname ) = &ora_fetch($csra) )  
   {
      $pdtblname =~ tr/a-z/A-Z/;
      print "<BR><HR>\n";
      print "<BR>Data Table is $pdtblname;<BR> Default Fields:<P>\n";
      $pdtablename = $pdtblname;


      &ora_bind ($csrb, $pdtablename);
      $ii=0;
      while ( ($fname, $cname, $fdname, $forder) = &ora_fetch($csrb) ) 
      {
         $ii++;
         print "default order_num is $forder for $fname alias $fdname, 
            with colname $cname <BR>\n";
         $ord[$ii] = $forder; 
         $fieldname[$ii] = $fname;
         $fielddisplayname[$ii] = $fdname;
         $columnname[$ii] = $cname;
      }
      print "<CENTER><TABLE BORDER=3 WIDTH=70%>\n";
      print "<TR>\n";
      for ($i=1; $i <= $#ord; $i++) {
         print "<TD ALIGN=\"center\"> $columnname[$i] </TD>\n";
      }
      print "</TR>\n";
      print "</TABLE></CENTER>\n";

      for ($i=1; $i <= $#ord; $i++) {
         $columnname[$i] = '';
      }

      print "<P>Display Fields:<P>\n";
      &ora_bind ($csrc, $pdtablename);
      while ( ($fcname, $ccname, $fcdname, $fcorder, $funits) = &ora_fetch($csrc) ) 
      {
         print "display order_num is $fcorder for $fcname alias $fcdname, 
            with colname $ccname, units $funits <BR>\n";
      }
   }    
   &ora_close($csrb);
   &ora_close($csra);
   &ora_close($csrc);
}

# ***************************************************
# Get display fields and build page2 table
# ***************************************************
sub write_display_page2
{
   local ($modelin, $mdlsz) = @_;

   &write_comment("Input model is $modelin; size is $mdlsz");

   $csra = &ora_open($lda, $GET_TABLENAME)        || print "failed to open  $GET_TABLENAME";
   $csrb = &ora_open($lda, $GET_DISPLAY_FIELDS)   || print "failed to open $GET_DISPLAY_FIELDS";
   &write_comment ("GET TABLENAME is $GET_TABLENAME");
   &write_comment ("GET DISPLAY FIELDS is $GET_DISPLAY_FIELDS");

#  Get Name of Product Data Table for input model
# -----------------------------------------------
   $pdmodel = $modelin;
   $pdmdlsize = $mdlsz;
   &ora_bind($csra, $pdmodel);
   while (  ($pdtblname) = &ora_fetch($csra) )
   {
      $pdtablename = $pdtblname;
      $pdtablename =~ tr/a-z/A-Z/;
      &write_comment("data table is $pdtablename");
   }
   &ora_close ($csra);


#  Get the default fields for pdtablename
#  --------------------------------------
   if ($pdtablename ne '')
   {
      &ora_bind ($csrb, $pdtablename); 
      $ii=0;
      while ( ($fname, $cname, $fdname, $forder, $funits) = &ora_fetch($csrb) ) 
      {
         &write_comment("fname is $fname; cname is $cname; units is $funits");
         $ord[$ii] = $forder; 
         $fieldname[$ii] = $fname;
         $fielddisplayname[$ii] = $fdname;
         $columnname[$ii] = $cname;
         if ($columnname[$ii] eq '')
         {
            $columnname[$ii] = $fieldname[$ii].'*';
         }
         $units[$ii] = $funits;
         $ii++;
      }
      &write_comment("ii is $ii; max order is $#ord");

#  Get Cursor for Correct Data Table and determine indexes for default fields
#  --------------------------------------------------------------------------

      if ($pdtablename eq 'CAES_CHILLER')                  { $GET_DATA = $CAES_CHILLER }
      if ($pdtablename eq 'CMUS_AIR_CONDENSER')            { $GET_DATA = $CMUS_AIR_CONDENSER }
      if ($pdtablename eq 'CMUS_AIR_HANDLER')              { $GET_DATA = $CMUS_AIR_HANDLER }
      if ($pdtablename eq 'CMUS_AIR_TERMINAL')             { $GET_DATA = $CMUS_AIR_TERMINAL }
      if ($pdtablename eq 'CMUS_AIR_TERMINAL_BOX')         { $GET_DATA = $CMUS_AIR_TERMINAL_BOX }
      if ($pdtablename eq 'CMUS_BOOT_DIFFUSER')            { $GET_DATA = $CMUS_BOOT_DIFFUSER }
      if ($pdtablename eq 'CMUS_CHILLER')                  { $GET_DATA = $CMUS_CHILLER }
      if ($pdtablename eq 'CMUS_DUAL_FUEL_HEAT_PUMP')      { $GET_DATA = $CMUS_DUAL_FUEL_HEAT_PUMP }
      if ($pdtablename eq 'CMUS_FANCOILS')                 { $GET_DATA = $CMUS_FANCOILS }
      if ($pdtablename eq 'CMUS_INDOOR_HORZ_PACK')         { $GET_DATA = $CMUS_INDOOR_HORZ_PACK }
      if ($pdtablename eq 'CMUS_INDOOR_VERT_PACK')         { $GET_DATA = $CMUS_INDOOR_VERT_PACK }
      if ($pdtablename eq 'CMUS_INDUCTION_UNIT')           { $GET_DATA = $CMUS_INDUCTION_UNIT }
      if ($pdtablename eq 'CMUS_LPACKROOF_EHEAT_ECOOL')    { $GET_DATA = $CMUS_LPACKROOF_EHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_LPACKROOF_GHEAT_ECOOL')    { $GET_DATA = $CMUS_LPACKROOF_GHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACKROOF_EHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_EHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACKROOF_GHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_GHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACK_AIR_HANDLER')         { $GET_DATA = $CMUS_PACK_AIR_HANDLER }
      if ($pdtablename eq 'CMUS_PACK_ELEC_COOL')           { $GET_DATA = $CMUS_PACK_ELEC_COOL }
      if ($pdtablename eq 'CMUS_PACK_GAS_HEAT_ELEC_COOL')  { $GET_DATA = $CMUS_PACK_GAS_HEAT_ELEC_COOL }
      if ($pdtablename eq 'CMUS_PACK_HEATING_AND_COOLING') { $GET_DATA = $CMUS_PACK_HEATING_AND_COOLING }
      if ($pdtablename eq 'CMUS_PACK_HEATPUMP')            { $GET_DATA = $CMUS_PACK_HEATPUMP }
      if ($pdtablename eq 'CMUS_PACK_ROOFTOP_HEATPUMP')    { $GET_DATA = $CMUS_PACK_ROOFTOP_HEATPUMP }
      if ($pdtablename eq 'CMUS_PACK_TERMINAL_UNIT')       { $GET_DATA = $CMUS_PACK_TERMINAL_UNIT }
      if ($pdtablename eq 'CMUS_SPLIT_SYSTEM')             { $GET_DATA = $CMUS_SPLIT_SYSTEM }
      if ($pdtablename eq 'CMUS_SPLIT_SYSTEM_HEATPUMP')    { $GET_DATA = $CMUS_SPLIT_SYSTEM_HEATPUMP }
      if ($pdtablename eq 'CMUS_WATER_SOURCE_HEATPUMP')    { $GET_DATA = $CMUS_WATER_SOURCE_HEATPUMP }
      if ($pdtablename eq 'RAC_UNITS_HC')                  { $GET_DATA = $RAC_UNITS_HC }
      if ($pdtablename eq 'RAC_UNITS_COOL_ONLY')           { $GET_DATA = $RAC_UNITS_COOL_ONLY }
      if ($pdtablename eq 'RAC_UNITS_HEAT_COOL')           { $GET_DATA = $RAC_UNITS_HEAT_COOL }
      if ($pdtablename eq 'RAC_UNITS_HEAT_PUMP')           { $GET_DATA = $RAC_UNITS_HEAT_PUMP }

      print "<P><HR><P>\n";
  #   print "product data table name is $pdtablename <BR>\n";
      &write_comment("query is $GET_DATA ");

      $csrc = &ora_open($lda, $GET_DATA)      || print "failed to open $GET_DATA\n";
      @fldnames  = &ora_titles($csrc);
      @flengths  = &ora_lengths($csrc);
      @ftypes    = &ora_types($csrc);

#  Get the indexes for the $#ord display fields 
#  -----------------------------------------------
      for ($ii=0; $ii <= $#ord; $ii++)
      {
         $fieldname[$ii] =~ tr/a-z/A-Z/;
         # Get matching fieldname
         for ($idat=0; $idat <= $#fldnames; $idat++) 
         {
            $fldnames[$idat] =~ tr/a-z/A-Z/;
            if ($fieldname[$ii] eq $fldnames[$idat] )
            {
               $tord[$ii] = $idat;
          #    print "$idat, tord[$ii] = $tord[$ii], fieldname[$ii]=$fieldname[$ii],";
               &write_comment("fldname = $fldnames[$tord[$ii] ]");
            }
         }
      }

      print "<A NAME=\"product_data\"></A>\n";
      print "<CENTER>\n";
      print "<FONT SIZE=4> Product Specifications for Model $pdmodel </FONT><P>\n";


      print "<CENTER>\n";
      print "<TABLE BORDER=3 \n";
      print "<TR><TD ALIGN=left>Model Size</TD>\n";
      print "<TD ALIGN=center>$pdmdlsize</TD></TR>\n";
      &ora_bind ($csrc, $pdmodel, $pdmdlsize);
      while (  ( @pdata) = &ora_fetch($csrc)  )
      {
          &write_comment("first element is $pdata[0], number is $#ord");
          for ($ij =0; $ij<= $#ord; $ij++) 
          {
             if ($pdata[$tord[$ij] ] ne '')
             {
                print "<TR> \n";
                print "<TD ALIGN=\"left\"> $columnname[$ij]";  
                if ($units[$ij] ne '') { print "  ($units[$ij])"; }
                print "</TD>";
                print " <TD ALIGN=\"center\"> $pdata[$tord[$ij] ] </TD>";
                print "</TR>\n";
             }
          }
      }
      print "</TABLE></CENTER>\n";
      &ora_close ($csrc);
   }
   &ora_close($csrb);
}

# ******************************************
# Writes the product page for input model
# ******************************************
sub write_modelpage
{
   local ($modelin) = @_;

   print "<A NAME=\"pagetop\"></A>\n";
   print "<P><BR>\n";

 # Check for product data
 # ----------------------
   $csrtab = &ora_open($lda, $GET_TABLENAME) || die $ora_errstr;
   &ora_bind ($csrtab, $modelin);
   ($tablename) = &ora_fetch($csrtab);
   if ($tablename ne '') 
   {
      print "<A HREF=\"#product_data\">";
      print "down to product data</A><BR>\n";
   }
   &ora_close($csrtab);

   $csra = &ora_open($lda, $GET_TEXT_FILENAME) || die $ora_errstr;
   $csrb = &ora_open($lda, $GET_GRAPHICS)      || die $ora_errstr;
   $csrc = &ora_open($lda, $CHECK_TEXT)        || die $ora_errstr;

   &ora_bind ($csra, $modelin);
   &ora_bind ($csrb, $modelin);
   &ora_bind ($csrc, $modelin, 'product page');

   print "<CENTER><FONT SIZE=5>\n";
   print "<P>Product Information for $modelin <BR>\n";
   print "</FONT></CENTER>\n";

   while ( ($photo_title, $photo_caption, $photo_filename, $photo_extension,
           $photo_pagetype, $photo_usage) = &ora_fetch($csrb) )
   {
   #  print "$model has photo file [$photo_filename]-[$photo_extension] for page [$photo_pagetype]<BR>\n";
      $photo_filename =~ tr/a-z/A-Z/;
      $photo_filename_uc = $photo_filename;
      $photo_filename =~ tr/A-Z/a-z/;
      $photo_filename_lc = $photo_filename;
      $photo_filename_uc = $photo_filename_uc.".jpg";
      $photo_filename_lc = $photo_filename_lc.".jpg";
      $IMG_SRC = $docpath."com_media/".$photo_filename_uc;
      $IMG_ALT = $docpath."com_media/".$photo_filename_lc;
   #  print "Unix photo filename is [$photo_filename]<P>\n";
   #  print "Unix IMG SRC is [$IMG_SRC]<BR>\n";

      $IMG_SRC = \"$IMG_SRC\"\n";
      $IMG_ALT = \"$IMG_ALT\"\n";
      print "<CENTER>\n";
   #  print "Image goes here<BR>\n";
      print "<IMG SRC =\"$IMG_SRC  ALT=\"$IMG_ALT ALIGN=CENTER>\n";
      print "</CENTER>\n";
   }
   &ora_close($csrb);
   print "<P><P>\n";

   while ( ($textno) = &ora_fetch ($csrc) )
   {
       $ntext = $textno;
     # print "number of text files is $ntext \n";
   }
   &ora_close ($csrc);

   if ($ntext > 0 )
   {
      while (  ($text_filename, $text_extension, $text_pagetype)
         = &ora_fetch($csra) )
      {
      #  print "$model has text file [$text_filename]-[$text_extension] for page [$text_pagetype]<BR>\n";
         $text_filename =~ s/\s/_/g;
         $text_filename =~ s/-/_/g;
         $text_filename = $text_filename.".html";
         $text_location = $textpath.$text_filename;
      #  print "Unix text filename is [$text_filename]<P>\n";
      #  print "Unix location is [$text_location<BR>\n";
         $text_link = $text_location;
      }
      &ora_close($csra);
      open(TEXTFILE, $text_link) || die "can't open filename $text_link\n";
      while (<TEXTFILE>)
      {
         chop;
         print "$_\n";
      } 
      close TEXTFILE;
   }

   &write_default_table ($modelin);   
}
