
  $GET_TABLE   = "SELECT distinct datatablename 
                    FROM commercial_products 
                   WHERE obsolete = 0
                   ORDER BY datatablename";
 
  $GET_TABLENAME   =
                 "SELECT datatablename, modelalias 
                    FROM commercial_products 
                   WHERE upper(model) = :1";
 
  $GET_DEFAULT_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         defaultfieldorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND defaultfield=1
                     AND upper(tablename) = :1";
 
  $GET_DISPLAY_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         displayorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND displayfield=1
                     AND upper(tablename) = :1";

  $GET_TEXT_FILENAME  =
                 "SELECT a.filename, a.extension, b.pagetype
                    FROM text_objects a, text_model_association b
                   WHERE upper(b.model) = :1
                     AND lower(b.usage) = 'product description'
                     AND a.textid = b.textid";

  $GET_GRAPHICS       =
                 "SELECT a.title, a.caption, a.filename, a.extension,
                         b.pagetype, b.usage
                    FROM graphic_objects a, 
                         graphic_model_association b
                   WHERE upper(b.model) = :1
                     AND lower(b.pagetype) LIKE 'product page%'
                     AND a.graphicid = b.graphicid";

  $CHECK_TEXT         =
                 "SELECT count(*) 
                    FROM text_model_association
                   WHERE upper(model) = :1
                     AND lower(usage) = :2";
  
#==================  segue page queries ==========

   $GET_MODEL     =
               "SELECT model, modelalias  
                  FROM commercial_products
                 WHERE generaltype = :1
                   AND specifictype = :2
                   AND obsolete = '0'
                 ORDER BY minclgcap";

  $GET_SEGUE_FILENAME  =
                 "SELECT t_filename, t_extension, t_pagetype
                    FROM model_text_pp_view
                   WHERE upper(model) = :1
                     AND lower(t_usage) LIKE 'segue to product%'";

  $CHECK_SEGUE_TEXT         =
                 "SELECT count(*) 
                    FROM text_model_association
                   WHERE upper(model) = :1
                     AND lower(usage) LIKE 'segue to product%'";
  
  $COUNT_MODELS  =
               "SELECT count(*)
                  FROM commercial_products
                 WHERE upper(model) LIKE :1
                   AND obsolete = 0";

  $GET_MODEL_BY_SUBSTR     =
               "SELECT model, modelalias  
                  FROM commercial_products
                 WHERE upper(model) LIKE :1 
                   AND obsolete = 0
                 ORDER BY model";


