#!/usr/local/bin/perl54

# -----------------------
# filename:
# write_download_segue.pl
# revised for perl5 9/98 
# written august 1996
# author Barbara Mihalas
# -----------------------

$DEBUG = 0;

require 'getopts.pl';

use Oraperl;

require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_specs.pl';
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_paths.pl';

# ===== HTML setup ======
  &html_header;
# ===== HTML setup ======


# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

  &write_comment("path for pdf hrefs is $dldirectory\n");

# ==============  define cursors =============================
  $GET_HEADER_DOC =
                 "SELECT filename, extension
                    FROM text_objects 
                   WHERE textid = :1";
 
# Elec lit (64); Elec catalog (51); CAD templates (37)

# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

  &get_query;

  $modelno = $value[0];
  $dltype  = $value[1];

# print "<P>Input model is $modelno for download type $dltype<BR>\n";

  &print_seguepage($modelno, $dltype);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================

# =============== start of subroutines =======================
# ******************************************************
# Prints Download Segue Page for Comm level 1 documents
# ******************************************************
sub print_seguepage
{
   local ($modelin, $dltypein) = @_;

   $GET_ELEC_LIT_LINKS  =
              "SELECT downloadfiletype, filename, extension, description,
                      fileformat, disksize, downloadable, descriptionid,
                      licenseid, installid, downloadmodel 
                 FROM download_links
                WHERE model = :1
                  AND upper(extension) LIKE :2
                  AND obsolete IS NULL
                  AND downloadable = 1
                  AND upper(downloadfiletype) LIKE :3";

   $GET_TEXT_FILENAME =
              "SELECT filename, extension 
                 FROM text_objects
                WHERE textid = :1";

   $GET_TYPE_DESCRIPTION =
              "SELECT description 
                 FROM download_object_types
                WHERE downloadfiletype = :1";

   $csrdoc = &ora_open ($lda, $GET_HEADER_DOC) 
                   || print "failed to open cursor $GET_HEADER_DOC<BR>\n";
   $csrtxt = &ora_open ($lda, $GET_TEXT_FILENAME) 
                   || print "failed to open cursor $GET_TEXT_FILENAME<BR>\n";
   $csrtdesc = &ora_open ($lda, $GET_TYPE_DESCRIPTION) 
                   || print "failed to open cursor $GET_TYPE_DESCRIPTION<BR>\n";

   $textpath  = '/oradata/disk4/carrier/wpdv/com_docs/';   #dv

   if ($dltypein eq 'eleclit'  ) { &ora_bind ($csrdoc, '474'); }  #this set is correct
   if ($dltypein eq 'eleccat'  ) { &ora_bind ($csrdoc, '51');  }
   if ($dltypein eq 'template' ) { &ora_bind ($csrdoc, '64');  } 
   if ($dltypein eq 'E20-II' )   { &ora_bind ($csrdoc, '37');  }  

   ($docname) = &ora_fetch($csrdoc); 
   $docname   =~ s/-/_/g;
   $docname   =~ s/\s/_/g;
   $unixfilename = $docname.'.html';
   $unixfile = $textpath.$unixfilename;

   &write_comment("unix filename is $unixfilename<BR>\n");

   open (SEGUEDOC, $unixfile) || print "failed to open $unixfilename<BR>\n";
   while (<SEGUEDOC>)
   {
      chop;
      print "$_\n";
   } 
   close SEGUEDOC;

   print "<P><P>\n";

   print "<UL>\n";
   $csrlinks = &ora_open($lda, $GET_ELEC_LIT_LINKS) || 
        print "failed to open get_download_link cursor<BR>\n"; 

   if ($dltypein eq 'eleclit'  )
   { 
      &ora_bind($csrlinks, $modelin, 'PDF', '%%');
   }
   if ($dltypein eq 'eleccat'  )
   {
      &ora_bind($csrlinks, $modelin, '%%', 'E-CAT');
   }
   if ($dltypein eq 'template'  )
   {
      &ora_bind($csrlinks, $modelin, '%%', 'CAD%TEMPLATE');
   }
   if ($dltypein eq 'E20-II'  )
   {
      &ora_bind($csrlinks, $modelin, '%%', 'E20-II');
   }

#  $dldirectory = 'abd';
   while ( ($dlftype, $fname, $ext, $desc, $format, $sizekb, $ok, 
             $desc_id, $lic_id, $inst_id, $dlmodel) 
          = &ora_fetch($csrlinks) )
   {
      &write_comment("license_id = $lic_id; install_id = $inst_id; description_id = $desc_id\n");
      if  ($ok =1 )
      {
         if ($fname ne '') 
         {
            &ora_bind($csrtdesc, $dlftype);
            while ( ($typedesc) = &ora_fetch($csrtdesc) )
            {  $typeheader = $typedesc; 
            }

            $htfname = $fname.'.'.$ext;
            &write_comment("Full htfilename is $htfname\n");

            $lid = $lic_id;
            $licnum = 0;
            &ora_bind($csrtxt, $lid);
            while ( ($lic_filename, $lic_ext) = &ora_fetch($csrtxt) )
            {
               $lic_filename =~ s/ /_/g;
               $lic_filename =~ s/-/_/g;
               $licnum = $licnum +1;
               &write_comment("license filename is $lic_filename; extension is $lic_ext\n");
            }

            if ($licnum > 0)
            {
               $htmodel = $modelno; $htmodel =~ s/ /+/g;  $htmodel =~ s/-/%2D/g;
               $htdlmdl = $dlmodel; $htdlmdl =~ s/ /+/g;  $htdlmdl =~ s/-/%2D/g;
               $licstring = '/write_download_license.sh?licid='.$lic_id.'&modelno='.$htmodel.'&dlmdl='.$htdlmdl;
               $licstring = $licstring.'&instid='.$inst_id.'&dltype='.$dltypein;
               &write_comment("license string is $licstring\n");
               if ($typeheader eq '') {$typeheader = join('.', $fname, $ext); }
               print "<B><A HREF=\"$plpath$licstring\">$typeheader</A></B><P>\n";
            }
            else
            {
               if ($typeheader eq '') {$typeheader = join('.', $fname, $ext); }
               print "<B><A HREF=\"$dldirectory$fname.$ext\">$typeheader</A></B><P>\n";
                 # filesize = $sizekb KB<P>\n";
               &write_comment("license_id = $lic_id; install_id = $inst_id; description_id = $desc_id\n");
            }

            &ora_bind($csrtxt, $inst_id);
            ($inst_filename, $inst_ext) = &ora_fetch($csrtxt);
               $inst_filename =~ s/ /_/g;
               $inst_filename =~ s/-/_/g;
               &write_comment("install filename is $inst_filename; extension is $inst_ext\n");

            print "<UL>\n";
            print "$desc<P>\n";
            &ora_bind($csrtxt, $desc_id);
            while ( ($desc_filename, $desc_ext) = &ora_fetch($csrtxt) )
            {
               $desc_filename =~ s/ /_/g;
               $desc_filename =~ s/-/_/g;
               &write_comment("description filename is $desc_filename; extension is $desc_ext\n");
               $descdocname = $desc_filename.'.html';
               
               open (DESCFILE, "$textpath$descdocname") ||
                            print "failed to open $textpath$descdocname\n";
               
               while (<DESCFILE>)
               {
                   chop;
                   print "$_\n";
               }
            }
            print "</UL>\n";
         }
      }
   }
   &ora_close($csrlinks);
   &ora_close($csrdoc);
}
