#!/usr/local/bin/perl54
# -----------------------
# filename:
# write_com_types_cd.pl
# written April 1997
# author Barbara Mihalas
# -----------------------

require 'getopts.pl';

use Oraperl;

require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_specs.pl';
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/download_queries.pl';
# Elec lit (64); Elec catalog (51); CAD templates (37)
# ==============  end of cursors =============================

# ===== oraperl setup ========
  &oracle_login;
# ===== oraperl setup ========

# ==============  end of oraperl setup =======================
# ============================================================


  $GET_GENERALTYPE   =
                 "SELECT DISTINCT generaltype
                    FROM commercial_products
                   WHERE obsolete = 0
                   ORDER BY generaltype";

  $GET_SPECIFICTYPE  =
                  "SELECT DISTINCT specifictype
                     FROM commercial_products
                    WHERE generaltype = :1
                      AND obsolete = 0
                    ORDER BY specifictype";

  $GET_GENTYPEALIAS  =
                 "SELECT gtalias
                    FROM gentypealias
                   WHERE generaltype = :1";

  $GET_SPECTYPEALIAS =
                 "SELECT stalias
                    FROM spectypealias
                   WHERE specifictype = :1";

# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

  $csrgen = &ora_open($lda, $GET_GENERALTYPE)    || die $ora_errstr;
  $csrspc = &ora_open($lda, $GET_SPECIFICTYPE)   || die $ora_errstr;
  $csrgt  = &ora_open($lda, $GET_GENTYPEALIAS)   || die $ora_errstr;
  $csrst  = &ora_open($lda, $GET_SPECTYPEALIAS)  || die $ora_errstr;

  $basename = "CPLIST";
  $subdirectory = $basename;
  $directory = $pdpdirpath.$subdirectory;
      
  &write_dframepage($directory, $basename);

  &ora_close($csrgen);
  &ora_close($csrspc);
  &ora_close($csrgt);
  &ora_close($csrst);

# ==================end  body of program =====================
# ============================================================

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================


# =============== start of subroutines =======================

# ******************************************
# write the frameD page
# ******************************************
sub write_dframepage
{
   local ($subdir, $namestr ) = @_;

   &html_header_file;

   print "<!-- 11/8/97 revision --><BR>\n";

   &caw_frameD_back_header;

   print "<P><P> \n";

   $pfilename = 'ptypes.html';
   $ptypefile = $textpath.$pfilename;
   open (PTYPES, "<$ptypefile")
        || print LOGFILE "failed to open $ptypefile for reading\n";
   while (<PTYPES>)
   {
      chop;
      print "$_\n";
   }
   close PTYPES;

   print "<TABLE BORDER=0>\n";
   while ( ($generaltype) = &ora_fetch($csrgen) )
   {
      
      print "<TR><TD>\n";
      print "<A NAME=\"$generaltype\"></A>\n";
      $uppergentype = $generaltype;
      $uppergentype =~ tr/a-z/A-Z/;
      print "<P><B> $generaltype </B><BR>\n";
      print "<UL>\n";
      $hgen = $generaltype;
      $hgen =~ s/ /+/g;
      $hgen =~ s/-/%2D/g;
 
      &ora_bind ( $csrspc, $generaltype); 
      while ( ($specifictype) = &ora_fetch($csrspc) ) 
      {

         $hsp = $specifictype;
         $hsp =~ s/ /+/g;
         $hsp =~ s/-/%2D/g;
         $spectype = join('$', $hgen, $hsp);
 
      # write the link for the specific type
         print "<A HREF=\"$oraclepath/CPUT.llm?spec_type=$spectype\"  
           TARGET=\"_parent\" > $specifictype </A> <BR>\n";
      }
      print "</UL>\n";
      print "</TD>\n";
      print "<TD VALIGN=\"top\"><A HREF=\"#pagetop\">\n";
      print "<FONT SIZE=2>up to product types</FONT></A>\n";
      print "</TD></TR>\n";
 
   }
   print "</TABLE>\n";

}
